package com.carrotsearch.maven.plugins.junit4;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on junit4-maven-plugin.<br/> Call <pre>  mvn junit4:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Dec 17 11:21:02 CET 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "com.carrotsearch.randomizedtesting:junit4-maven-plugin:2.0.7", 0 );
        append( sb, "", 0 );

        append( sb, "RandomizedTesting JUnit4 Maven Plugin", 0 );
        append( sb, "Foundation classes and rules for applying the principles of Randomized Testing.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 2 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "junit4:help", 0 );
            append( sb, "Display help information on junit4-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0junit4:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "junit4".equals( goal ) )
        {
            append( sb, "junit4:junit4", 0 );
            append( sb, "Run tests using a delegation to Randomized Testing\'s JUnit4 ANT task.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "additionalClasspathElements", 2 );
                append( sb, "Additional elements to be appended to the classpath.", 3 );
                append( sb, "", 0 );

                append( sb, "assertions", 2 );
                append( sb, "Raw assertions configuration. Same XML as for ANT.", 3 );
                append( sb, "", 0 );

                append( sb, "balancers", 2 );
                append( sb, "Raw balancers configuration. Same XML as for ANT.", 3 );
                append( sb, "", 0 );

                append( sb, "classesDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "The directory containing generated classes of the project being tested. This will be included after testClassesDirectory.", 3 );
                append( sb, "", 0 );

                append( sb, "classpathDependencyExcludes", 2 );
                append( sb, "List of dependencies to exclude from the test classpath. Each dependency string must follow the format groupId:artifactId. For example: org.acme:project-a\nThis is modeled after surefire. An excluded dependency does not mean its transitive dependencies will also be excluded.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classpathDependencyScopeExclude", 2 );
                append( sb, "A dependency scope to exclude from the test classpath. The scope can be one of the following scopes:\n-\tcompile - system, provided, compile\n-\truntime - compile, runtime\n-\ttest - system, provided, compile, runtime, test\n", 3 );
                append( sb, "", 0 );

                append( sb, "dir", 2 );
                append( sb, "Base directory to invoke slave VMs in. Also note isolateWorkingDirectories parameter.", 3 );
                append( sb, "Expression: ${project.build.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "dynamicAssignmentRatio (Default: 0.25)", 2 );
                append( sb, "Specifies the ratio of suites moved to dynamic assignment list. A dynamic assignment list dispatches suites to the first idle slave JVM. Theoretically this is an optimal strategy, but it is usually better to have some static assignments to avoid communication costs.\nA ratio of 0 means only static assignments are used. A ratio of 1 means only dynamic assignments are used.\n\nThe list of dynamic assignments is sorted by decreasing cost (always) and is inherently prone to race conditions in distributing suites. Should there be an error based on suite-dependency it will not be directly repeatable. In such case use the per-slave-jvm list of suites file dumped to disk for each slave JVM. (see leaveTemporary parameter).\n", 3 );
                append( sb, "", 0 );

                append( sb, "environmentVariables", 2 );
                append( sb, "Adds an environment variable to any forked JVM.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "A list of <exclude> elements specifying the tests (by pattern) that should be excluded in testing. When not specified defaults to:\n<exclude>**/*$*.class</exclude>\nThis patterns excludes any nested classes that might otherwise be included.", 3 );
                append( sb, "", 0 );

                append( sb, "failureProperty", 2 );
                append( sb, "Property to set to \'true\' if there is a failure in a test. The use of this property is discouraged in Maven (builds should be declarative).", 3 );
                append( sb, "", 0 );

                append( sb, "haltOnFailure (Default: true)", 2 );
                append( sb, "Stop the build process if there were failures or errors during test execution.", 3 );
                append( sb, "", 0 );

                append( sb, "heartbeat (Default: 0)", 2 );
                append( sb, "Sets the heartbeat used to detect inactive/ hung forked tests (JVMs) to the given number of seconds. The heartbeat detects no-event intervals and will report them to listeners. Notably, TextReport report will emit heartbeat information (to a file or console).\nSetting the heartbeat to zero means no detection.\n", 3 );
                append( sb, "", 0 );

                append( sb, "includes", 2 );
                append( sb, "A list of <include> elements specifying the tests (by pattern) that should be included in testing. When not specified defaults to:\n<include>**/*Test.class</include>\n<include>**/Test*.class</include>\nNote that this may result in nested classes being included for tests. Use proper exclusion patterns.", 3 );
                append( sb, "", 0 );

                append( sb, "isolateWorkingDirectories (Default: true)", 2 );
                append( sb, "If set to true each slave JVM gets a separate working directory under whatever is set in dir. The directory naming for each slave follows: \'Snum\', where num is slave\'s number. Directories are created automatically and removed unless leaveTemporary is set to true.", 3 );
                append( sb, "", 0 );

                append( sb, "junitArtifactName (Default: junit:junit)", 2 );
                append( sb, "Specifies the name of the JUnit artifact used for running tests. JUnit dependency must be in at least version 4.10.", 3 );
                append( sb, "Expression: ${junitArtifactName}", 3 );
                append( sb, "", 0 );

                append( sb, "jvm (Default: java)", 2 );
                append( sb, "The command used to invoke the Java Virtual Machine, default is \'java\'. The command is resolved by java.lang.Runtime.exec().", 3 );
                append( sb, "", 0 );

                append( sb, "jvmArgs", 2 );
                append( sb, "Add an additional argument to any forked JVM.", 3 );
                append( sb, "", 0 );

                append( sb, "jvmOutputAction (Default: pipe,warn)", 2 );
                append( sb, "What should be done on unexpected JVM output? JVM may write directly to the original descriptors, bypassing redirections of System.out and System.err. Typically, these messages will be important and should fail the build (permgen space exceeded, compiler errors, crash dumps). However, certain legitimate logs (gc activity, class loading logs) are also printed to these streams so sometimes the output can be ignored.\nAllowed values (any comma-delimited combination of): ignore, pipe, warn, fail.\n", 3 );
                append( sb, "Expression: ${jvmOutputAction}", 3 );
                append( sb, "", 0 );

                append( sb, "leaveTemporary", 2 );
                append( sb, "Set to true to leave temporary files for diagnostics.", 3 );
                append( sb, "", 0 );

                append( sb, "listeners", 2 );
                append( sb, "Raw listeners configuration. Same XML as for ANT.", 3 );
                append( sb, "", 0 );

                append( sb, "maxMemory", 2 );
                append( sb, "Set the maximum memory to be used by all forked JVMs. The value as defined by -mx or -Xmx in the java command line options.", 3 );
                append( sb, "", 0 );

                append( sb, "parallelism (Default: 1)", 2 );
                append( sb, "The number of parallel slaves. Can be set to a constant \'max\' for the number of cores returned from Runtime.availableProcessors() or \'auto\' for sensible defaults depending on the number of cores. The default is a single subprocess.\nNote that this setting forks physical JVM processes so it multiplies the requirements for heap memory, IO, etc.\n", 3 );
                append( sb, "", 0 );

                append( sb, "printSummary (Default: true)", 2 );
                append( sb, "Prints the summary of all executed, ignored etc. tests at the end.", 3 );
                append( sb, "", 0 );

                append( sb, "seed", 2 );
                append( sb, "Initial random seed used for shuffling test suites and other sources of pseudo-randomness. If not set, any random value is set.\nThe seed\'s format is compatible with RandomizedRunner so that seed can be fixed for suites and methods alike. Unless the global prefix of randomized testing properties is changed, the seed can be overridden using \'tests.seed\' property.\n", 3 );
                append( sb, "Expression: ${tests.seed}", 3 );
                append( sb, "", 0 );

                append( sb, "shuffleOnSlave (Default: true)", 2 );
                append( sb, "Predictably shuffle tests order after balancing. This will help in spreading lighter and heavier tests over a single slave\'s execution timeline while still keeping the same tests order depending on the seed.", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Set this to \'true\' to skip running tests, but still compile them. Its use is NOT RECOMMENDED, but quite convenient on occasion.", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );

                append( sb, "surefireReportsDirectory (Default: ${project.build.directory}/surefire-reports)", 2 );
                append( sb, "This parameter adds a listener emitting surefire-compatible XMLs if no other listeners are added. If there are any configured listeners, this parameter is omitted (you can add a maven-compatible listener manually).", 3 );
                append( sb, "", 0 );

                append( sb, "sysouts (Default: false)", 2 );
                append( sb, "If set to true, any sysout and syserr calls will be written to original output and error streams (and in effect will appear as \'jvm output\'. By default sysout and syserrs are captured and proxied to the event stream to be synchronized with other test events but occasionally one may want to synchronize them with direct JVM output (to synchronize with compiler output or GC output for example).", 3 );
                append( sb, "", 0 );

                append( sb, "systemProperties", 2 );
                append( sb, "Adds a system property to any forked JVM.", 3 );
                append( sb, "", 0 );

                append( sb, "tempDir", 2 );
                append( sb, "The directory to store temporary files in.", 3 );
                append( sb, "Expression: ${project.build.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "The directory containing generated test classes of the project being tested. This will be included at the beginning of the test classpath.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
